From Peter.Breuer@prg Fri Apr 16 16:59:44 1993
Received: from comlab.ox.ac.uk (topaz.comlab) by prg.oxford.ac.uk 
	 id AA02144; Fri, 16 Apr 93 16:59:11 +0100
Received: by comlab.ox.ac.uk (4.1/comlab3.1)
	 id AA07741; Fri, 16 Apr 93 16:56:16 BST
From: Peter.Breuer@prg
Message-Id: <9304161556.AA07741@topaz.comlab.ox.ac.uk>
Subject: patch for preccx (with compliments)
Date: Fri, 16 Apr 93 16:56:14 BST
Cc: Peter.Breuer@prg (Peter Breuer)
X-Mailer: ELM [version 2.3 PL11]
Status: OR

There is a small (nondestructive) bug in the v230 source. It affects the
use of the `!' symbol in specification scripts.  A patch for v223 & v230
is  at  the  end  of  this  post,  and  must  be  applied to regain full
functionality.

The uniq0() code in common.c contains the bug.  I got an extra statement
accidentally  included in an if test.  The bug has been there since v223
at least.

The bug made the `!' effective only about 50% of the time. It made the !
implantation of a `boundary'  in  the  input  stream  only  sporadically
effective,  but  did  not  affect  the  ability  of  parsers  to  detect
backtracks across those boundaries that were successfully implanted,  or
to take the appropriate error action when they were detected.

To the user,  the bug would have manifested most often as a  _different_
sort of error (`incomplete parse',  perhaps,  or `failed parse') instead
of the expected `backtrack across cut'  error.  Backtrack errors  should
have  been  triggered  in  case of (a)  malformed input following (b)  a
corresponding `!' in the specification.

For example:

@ foo = <'a'> ! <'b'>
@     | ...

would have been expected to trigger a backtrack error on reciving the
input

    "ac"  or "a<EOL>"

but only the second input would have tripped it with the bug in place.

I have checked and tested a simple correction:  move the  `passcount++;'
statement outside the if-statement in the uniq0() code within common.c .
It completely restores the intended behaviour.

I am checking back to see how long the bug has been there.

Here are `before and after'  version  of  the  uniq0()  routine.  Please
patch.

************ BAD (v231-) ***************************************
STATUS  p_uniq0  ()  
{
	static int pcmax; pcmax=pc; pushEXIT;

        pc=0;
        pc=p_evaluate ();
        pc=0;   /* we have to write the next program in the right place */

        if ((yytchar!=EOF) && (0==*pstr)) {  /* then we can ask */
        	if (mygets(buffer,lvbuff)==0) {
                pstr=maxp=buffer;
                passcount++;

                return (SUCCESS);
                }
	}
	

	/* and don't reset STACKVALUE *value because we may later backtrack
        to earlier stack values */

	return (SUCCESS);
}
************ END BAD *******************************************


************ CORRECTED (v231+) *********************************
STATUS  p_uniq0  ()  
{
    static int pcmax; pcmax=pc; pushEXIT;

        pc=0;
        pc=p_evaluate ();
        pc=0;   /* we have to write the next program in the right place */

        if (yytchar!=EOF && 0==*pstr &&  /* then we can ask */
            mygets(buffer,lvbuff)==0)
                pstr=maxp=buffer;

                passcount++;             /* v232+ always done */

    /* and don't reset STACKVALUE *value because we may later backtrack
        to earlier stack values */

    return (SUCCESS);
}
******** END CORRECTED *****************************************


Much  easier that way,  anyway!  I think I inadvertently copied the code
from the lastuniq0()  function when creating  that  problem.  Lastuniq()
only  implants a boundary at EOL,  so it has to do a check on the stream
before incrementing the boundary count (passcount), but uniq0() ought to
have made an unconditional increment.

Sorry!

--
 Peter



